;;; Rygar sprite demo written by McGeezer (Graeme Cowie)
;;; Assembled using Goldroad ARM assembler (it's free)
;;; My first go at some dev work on the GBA.
;;;
        b setup

spr_pals
        @incbin sprites.pal
spr_pale

spr_imgs
        @incbin sprites.raw
spr_imge



keys_set
        @DCD 0x03ff

keys_io
        @DCD 0x04000130 ; Key pad

palram          
        @DCD 0x05000200 ;pallette ram address

charmem
        @DCD 0x06014000 ; character mem

videoram
        @DCD 0x06000000 ; video ram address
lcy
        @DCD 0x04000006 ; lcy register address
mode4
        @DCD 0x00001444 ; mode 4 config

oam
        @DCD 0x07000000 ; OAM memory

dma512
        @DCD 0x84000080 ; DMA (512 bytes) 

dma1024
        @DCD 0x84000100 ; DMA (1024 bytes) 

dma3sad
        @DCD 0x040000d4 ; DMA3 source address

dma3dad
        @DCD 0x040000d8 ; DMA3 dest address

dma3cnt
        @DCD 0x040000dc ; DMA control register

;; Attribute 0
spr_rot
        @DCD 0x0100
spr_sd
        @DCD 0x0200
spr_mod1
        @DCD 0x400
spr_mod2
        @DCD 0x800
spr_mos
        @DCD 0x1000
spr_col
        @DCD 0x2000
spr_sha1
        @DCD 0x4000
spr_sha2
        @DCD 0x8000

;; Attribute 1
spr_rot1
        @DCD 0x200
spr_rot2
        @DCD 0x400
spr_rot3
        @DCD 0x800
spr_hf
        @DCD 0x1000
spr_vf
        @DCD 0x2000
spr_siz1
        @DCD 0x4000
spr_siz2
        @DCD 0x8000

;; Attribute 2
spr_pri1
        @DCD 0x400
spr_pri2
        @DCD 0x800
spr_pal1
        @DCD 0x1000
spr_pal2
        @DCD 0x2000
spr_pal3
        @DCD 0x4000
spr_pal4
        @DCD 0x8000

startofiwramcode
        @textarea $03000000

dummy
        @DCD 0xffffffff

; Rygar moves
; 0=Standing (default)
; 1=running left
; 2=running right
; 3=jumping


rygarMOVE
        @DCD 0x0

rygaroldMOVE
        @DCD 0x0

rygarJUMP                               ; set to 1 when rygar is jumping
        @DCD 0x0

rygarTAB
        @DCD rygarANIMstand             ; 0
        @DCD rygarANIMleft              ; 1
        @DCD rygarANIMright             ; 2
        @DCD rygarANIMjump              ; 3
        @DCD rygarANIMsquat             ; 4

; y,x,flip,sprite number
sparray
        @DCD 100,20,0,0        ; sprite 0    ; Rygar sprite
        @DCD 0,0,0,0            ; sprite 1


; [sprite facing],[spry_inc],[sprx_inc],[sprite number]
rygarANIMstand
        @DCD 0                  ; Current animation
        @DCD 0,0,1,0
        @DCD 0x80000000

rygarANIMright
        @DCD 0x0                  ; Current animation pointer
        @DCD 0,3,36,0
        @DCD 0,3,36,0
        @DCD 0,3,36,0
        @DCD 0,3,36,0
        @DCD 0,3,37,0
        @DCD 0,3,37,0
        @DCD 0,3,37,0
        @DCD 0,3,37,0
        @DCD 0,3,38,0
        @DCD 0,3,38,0
        @DCD 0,3,38,0
        @DCD 0,3,38,0
        @DCD 0,3,39,0
        @DCD 0,3,39,0
        @DCD 0,3,39,0
        @DCD 0,3,39,0
        @DCD 0x80000000


rygarANIMleft
        @DCD 0x0                  ; Current animation pointer
        @DCD 0,0xfffffffd,36,0
        @DCD 0,0xfffffffd,36,0
        @DCD 0,0xfffffffd,36,0
        @DCD 0,0xfffffffd,36,0
        @DCD 0,0xfffffffd,37,0
        @DCD 0,0xfffffffd,37,0
        @DCD 0,0xfffffffd,37,0
        @DCD 0,0xfffffffd,37,0
        @DCD 0,0xfffffffd,38,0
        @DCD 0,0xfffffffd,38,0
        @DCD 0,0xfffffffd,38,0
        @DCD 0,0xfffffffd,38,0
        @DCD 0,0xfffffffd,39,0
        @DCD 0,0xfffffffd,39,0
        @DCD 0,0xfffffffd,39,0
        @DCD 0,0xfffffffd,39,0
        @DCD 0x80000000


rygarANIMjump
        @DCD 0                       ; Curreent animation pointer
        @DCD 0,0,2,0                 ; Rygar squats before he jumps
        @DCD 0,0,3,0
        @DCD 0xfffffffc,0,20,0                  ; up up and away
        @DCD 0xfffffffc,0,21,0
        @DCD 0xfffffffc,0,21,0
        @DCD 0xfffffffc,0,21,0
        @DCD 0xfffffffc,0,21,0
        @DCD 0xfffffffc,0,21,0                  ; up up and away
        @DCD 0xfffffffc,0,21,0
        @DCD 0xfffffffc,0,21,0
        @DCD 0xfffffffc,0,21,0
        @DCD 0xfffffffd,0,21,0
        @DCD 0xfffffffd,0,21,0
        @DCD 0xfffffffd,0,21,0
        @DCD 0xfffffffd,0,21,0
        @DCD 0xfffffffd,0,21,0
        @DCD 0xfffffffd,0,21,0
        @DCD 0xfffffffd,0,21,0
        @DCD 0xfffffffd,0,21,0
        @DCD 0xfffffffe,0,21,0
        @DCD 0xfffffffe,0,21,0
        @DCD 0xfffffffe,0,21,0
        @DCD 0xfffffffe,0,21,0
        @DCD 0xffffffff,0,21,0
        @DCD 0xffffffff,0,21,0
        @DCD 0xffffffff,0,21,0
        @DCD 0x0,0,21,0
        @DCD 0x0,0,21,0
        @DCD 0x1,0,21,0
        @DCD 0x1,0,21,0
        @DCD 0x1,0,21,0
        @DCD 0x2,0,21,0
        @DCD 0x2,0,21,0
        @DCD 0x2,0,21,0
        @DCD 0x2,0,21,0
        @DCD 0x3,0,21,0
        @DCD 0x3,0,21,0
        @DCD 0x3,0,21,0
        @DCD 0x3,0,21,0
        @DCD 0x3,0,21,0
        @DCD 0x3,0,21,0
        @DCD 0x3,0,21,0
        @DCD 0x3,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x4,0,21,0
        @DCD 0x80000000

rygarANIMsquat
        @DCD 0                  ; Current animation
        @DCD 0,0,2,0
        @DCD 0x80000000


spr_a
        @DCD 0x1000
spr_chr
        @DCD 0x200
spr_x
        @DCD 100
spr_y
        @DCD 100

        @endarea
endofiwramcode


setup
        mov r0,startofiwramcode
        mov r1,endofiwramcode
        mov r2,$03000000
setup_loop
        ldr r3,[r0]+4 !
        str r3,[r2]+4 !
        cmp r0,r1
        ble setup_loop

        ldr r10,palram
        ldr r9,videoram
        ldr r8,lcy      

        ldr r5,mode4    
        str r5,[r8,-6]          ; start mode 4

;;
;; Copy the pallete using DMA

        mov r0,spr_pals
        ldr r1,palram
        ldr r2,dma512
        ldr r3,dma3sad
        str r0,[r3]+4           ;; Source DMA address
        str r1,[r3]+4
        str r2,[r3]             ;; Start transfer

;;
;; Main loop here
;;

main
        mov r2,sparray                  ; draw rygar
        ldr r0,[r2]+4
        ldr r1,[r2]+4
        ldr r3,[r2]+4
        mov r4,0
        ldr r5,[r2]+4
        bl draw_sprite

        bl v_blank                      ; wait for vertical blank period
        bl keys                         ; get he GBA keys

        bl updateRYGAR                  ; Update rygar if he is moving


        mov r0,rygarJUMP                ; update rygar if he is jumping
        ldr r1,[r0]
        cmp r1,0x1
        bne main_end

        mov r3,rygarMOVE                ; set rygar to animate right
        ldr r6,[r3]
        mov r6,#3
        str r6,[r3]
        bl updateRYGAR                       ; update jump sprite

main_end
        b main


;
; animate rygar per each frame
;
updateRYGAR
        mov r1,rygarMOVE
        mov r2,rygaroldMOVE
        ldr r3,[r1]             ; current animation value
        ldr r4,[r2]             ; previous animation value
        cmp r3,r4               ; are we still running?
        beq update1

        str [r2],r3             ; store new value

update1
        add r3,r3,r3            ; convert to long words
        add r3,r3,r3

        mov r0,rygarTAB
        add r0,r0,r3            ; index to move animation.
        ldr r3,[r0]             ; Got animation address

                                ; r3 now is index to sprite data

        ldr r4,[r3]             ; get animation number in r4
        mov r2,r4               ; get animation number in r2 (work)
        mov r5,r3
        add r5,r5,#4            ; start of animation data in r5
        mov r6,r5               ; temp animation data in r6 (work)

        add r2,r2,r2            
        add r2,r2,r2

        add r2,r2,r2
        add r2,r2,r2

        add r6,r6,r2            ; index to animation data

        ldr r1,[r6]

        add r4,r4,#1            ; increment to next animation 

        mov r0,0x80000000

        cmp r1,r0
        bne update2
                                ; check to see if we were done jumping?
        mov r0,rygarMOVE
        ldr r1,[r0]
        cmp r1,#3               ; is rygar jumping?
        bne update3

        mov r0,rygarJUMP        ; his jump is finished though!
        ldr r1,[r0]             
        sub r1,r1,1
        str r1,[r0]             ; Reset Jump

update3
        sub r4,r4,r4            ;reset animation
        mov r6,r5
update2
        str r4,[r3]+4             ; Store New Animation

; r6 = pointer to animation data for sprite                                ;


        mov r1,sparray          ; load sprite array address

        ldr r0,[r6]+4           ; Sprite y Offset
        ldr r2,[r1]           ; Sprite 0 attributes           
        add r0,r0,r2
        str r0,[r1]+4

        ldr r0,[r6]+4           ; Sprite x Offset
        ldr r2,[r1]           ; Sprite 0 attributes           

        cmp r2,#210
        ble checkleft
        mov r2,#210

checkleft
        cmp r2,#3
        bge bounddone
        mov r2,#3

bounddone
        add r0,r0,r2


        str r0,[r1]+4

        add r1,r1,#4

        ldr r0,[r6]+4           ; Sprite y Offset
        ldr r2,[r1]           ; Sprite 0 attributes           
        ;add r0,r0,r2
        str r0,[r1]+4

        mov pc,lr

        
        
;
; Wait for V_blank to occur and start updates
;
v_blank
        mov r6,#0x4000000
        add r6,r6, #0x06
        ldrh r5,[r6]

        cmp r5,#160
        bne v_blank

        mov pc,lr


;
; Gameboy Advance Key handler routine
; Needs cleaing up.
;
keys
        ldr r0,keys_io          ; read keyset
        ldr r1,[r0]
        ldr r2,keys_set

        mov r3,rygarJUMP        ; Check see if rygar is jumping
        ldr r6,[r3]
        cmp r6,#1
        beq keys_loop

        mov r3,rygarMOVE        ; set rygars stance
        ldr r6,[r3]
        mov r6,0                ; animation 0 is the default
        str r6,[r3]

keys_loop
        cmp r1,r2               ; check see if any keys are being hit
        beq keys_end
        eor r3,r2,r1

keys_right
;; Test D-Pad Right
        mov r6,#$10
        tst r3,r6
        beq keys_left
        mov r3,r6
        orr r1,r1,r3
        
;
; Move player right
;
        mov r3,rygarMOVE         ; set rygar to animate right
        ldr r6,[r3]
        mov r6,#2
        str r6,[r3]

        mov r3,sparray
        add r3,r3,#8
        mov r6,0
        str r6,[r3]
        b keys_loop

keys_left
;; Test D-Pad Left
        mov r6,#$20
        tst r3,r6
        beq keys_up
        mov r3,r6
        orr r1,r1,r3
;
; Move player left
;
        mov r3,rygarMOVE         ; set rygar to animate right
        ldr r6,[r3]
        mov r6,#1
        str r6,[r3]

        mov r3,sparray
        add r3,r3,#8
        mov r6,0x1000           ; flip sprite left
        str r6,[r3]

        b keys_loop

keys_up
;; Test D-Pad UP
        mov r6,#$40
        tst r3,r6
        beq keys_down
        mov r3,r6
        orr r1,r1,r3
;
; Move player up
;

        mov r3,spr_y            ; Sprite Y on screen value
        ldr r6,[r3]
        sub r6,r6,#2
        str r6,[r3]
        b keys_loop

keys_down
;; Test D-Pad DOWN
        mov r6,#$80
        tst r3,r6
        beq keys_A
        mov r3,r6
        orr r1,r1,r3
;
; Move player down
;
        mov r3,rygarJUMP        ; Check see if rygar is jumping
        ldr r6,[r3]
        cmp r6,#1
        beq keys_loop

        mov r3,rygarMOVE         ; set rygar to animate right
        ldr r6,[r3]
        mov r6,#4
        str r6,[r3]

        b keys_loop

keys_A
;; Test D-Pad A
        mov r6,#$1
        tst r3,r6
        beq keys_B
        mov r3,r6
        orr r1,r1,r3

;
; Make player jump
;

        mov r3,rygarJUMP
        ldr r6,[r3]
        cmp r6,#1                ; is Rygar in mid jump?
        beq keys_loop

        mov r6,#1                ; no so set him to jump!
        str r6,[r3]               ; set rygar to jump

        b keys_loop

keys_B
;; Test D-Pad B
        mov r6,#$2
        tst r3,r6
        beq keys_sel
        mov r3,r6
        orr r1,r1,r3
        b keys_loop

keys_sel
;; Test Select
        mov r6,#$4
        tst r3,r6
        beq keys_sta
        mov r3,r6
        orr r1,r1,r3
        b keys_loop

keys_sta
;; Test Start
        mov r6,#$8
        tst r3,r6
        beq keys_end
        mov r3,r6
        orr r1,r1,r3
        b keys_loop

keys_end
        mov pc,lr


;;---------------------------------
;; draw_sprite routine
;; r0=Y co-ordinate of sprite
;; r1=X co-ordinate of sprite
;; r3=0x1000=Sprite Horizontal flipped 0=not
;; r4=sprite number to change
;; r5=sprite to change to          
;;---------------------------------
draw_sprite
        sub r2,r2,r2            ; clear r2 register

;; Setup attr0 sprite y data
        orr r2,r2,r1            ; Build Sprite X

        ldr r6,spr_sha2         ; Select 32x32 size sprite
        orr r2,r2,r6            
        orr r2,r2,r3            ; set flipping flag

        mov r6,65536            ; Send into high word
        mul r2,r2,r6

;; Setup attr1

        orr r2,r2,r0

        ldr r0,spr_col          ; Select 256 Colour sprites
        orr r2,r2,r0
        

;; Write the sprite register attr0 and attr1

        ldr r0,oam
        add r4,r4,r4            ;; index into OAM 
        add r4,r4,r4
        add r4,r4,r4
        add r0,r0,r4

        str r2,[r0]+4           ;; store register and increment
;
;

;;        ldr r2,spr_chr          ; Sprite character select

        mov r2,$200             ;;; REMEMBER TO FIX THIS GRAEME!!!!!!

;        mov r1,65536            ; Send into high word
;        mul r2,r2,r1

        str r2,[r0]+4           ;; Do other attributes

        mov r6,1024             ;; Index to sprite
        mul r5,r5,r6



;; Copy sprite using DMA

        mov r0,spr_imgs         ;; r0 = source
        add r0,r0,r5            ;; Index to sprite 
        ldr r1,charmem          ;; r1 = dest
        ldr r2,dma1024          ;; r2 = DMA size
        ldr r3,dma3sad          ;; r3 = DMA3 Base

        str r0,[r3]+4           ;; Source DMA address
        str r1,[r3]+4
        str r2,[r3]             ;; Start transfer 

        mov pc,lr

